---
- name: Verify
  hosts: all
  become: true
  become_user: root
  tasks:

  - name: Set container runtime to docker
    set_fact:
      container_runtime: "docker"
    when: not ( ansible_os_family | lower == "redhat" and ansible_distribution_major_version | int >= 8 )

  - name: Set container runtime to podman
    set_fact:
      container_runtime: "podman"
    when: ansible_os_family | lower == "redhat" and ansible_distribution_major_version | int >= 8

  - name: Ensure test role is absent
    file:
      name: testrole
      state: absent

  - name: Run molecule init
    shell: |
      export LC_ALL=en_US.utf-8
      export LANG=en_US.utf-8
      export PATH=/usr/local/bin:$PATH
      molecule init role testrole -d {{ container_runtime }}
    args:
      executable: /bin/bash
    register: molecule_init

  - name: Search molecule output for 'sucessfully' string
    assert:
      that: "'successfully' in molecule_init.stdout"

  - name: Download docker test image
    command: "{{ container_runtime }} pull hello-world"

  - name: Run docker test image
    command: "{{ container_runtime }} run hello-world"
    register: docker_test

  - name: Search docker outpout for 'Hello' string
    assert:
      that: "'Hello from Docker' in docker_test.stdout"

  - name: Remove create.yml from molecule test set
    file:
      path: testrole/molecule/default/create.yml
      state: absent

  - name: Add molecule configuration including linter definition
    copy:
      dest: testrole/molecule/default/molecule.yml
      mode: "0644"
      content: |
        ---
        dependency:
          name: galaxy
          driver:
            name: docker
        platforms:
          - name: instance
            image: docker.io/pycontribs/centos:7
            pre_build_image: true
        provisioner:
          name: ansible
        verifier:
          name: ansible
        lint:
          set -e
          yamllint .
          ansible-lint tasks

  - name: Run complete molecule test sequence
    shell: |
      export LC_ALL=en_US.utf-8
      export LANG=en_US.utf-8
      export PATH=/usr/local/bin:$PATH
      molecule test -d {{ container_runtime }}
    args:
      chdir: testrole
      executable: /bin/bash
    register: molecule_test

  - name: Verify test has run successfully
    assert:
      that: molecule_test.rc == 0
